#-----------------------------------------------------------------------------
# messages compilation options 
OPTION ( BBTK_COMPILE_MESSAGES         "Compile bbtk messages ?"         ON)
OPTION ( BBTK_COMPILE_DEBUG_MESSAGES   "Compile bbtk debug messages ?"   ON)
OPTION ( BBTK_COMPILE_WARNING_MESSAGES "Compile bbtk warning messages ?" ON)
OPTION ( BBTK_COMPILE_ERROR_MESSAGES   "Compile bbtk error messages ?"   ON)
#-----------------------------------------------------------------------------
OPTION(BUILD_APPLICATIONS "Build Applications (bbi, bbfy, ...)" ON)
OPTION(BUILD_BBS_APPLI_BINARIES "Build binaries for bbs applications of all packages" OFF)
##EED   SWITCH_ON_IF_BUILD_ALL(BUILD_BBS_APPLI_BINARIES)
#-----------------------------------------------------------------------------
OPTION(BUILD_BBTK_DOC "Build documentation for bbtk." OFF)
SWITCH_ON_IF_BUILD_ALL(BUILD_BBTK_DOC)
#-----------------------------------------------------------------------------
IF(BUILD_BBTK_DOC)
  
  OPTION(BUILD_BBTK_DOC_PACKAGE 
    "Build bbtk packages documentation (bbi+dot)." 	 ON)
  OPTION(BUILD_BBTK_DOC_DOXYGEN 
    "Build doxygen documentation (doxygen)." 		 ON)
  OPTION(BUILD_BBTK_DOC_GUIDES_PDF 
    "Build bbtk Guides', PDF format (latex)." 	 ON)
  OPTION(BUILD_BBTK_DOC_GUIDES_HTML 
    "Build bbtk Guides', HTML format (latex+tth)."	 ON)

ELSE(BUILD_BBTK_DOC)
  
  IF(BUILD_BBTK_DOC_PACKAGE)
    SET(BUILD_BBTK_DOC_PACKAGE OFF CACHE BOOL 
      "Build bbtk packages documentation (bbdoc+dot)."	FORCE)
  ENDIF(BUILD_BBTK_DOC_PACKAGE)
  IF(BUILD_BBTK_DOC_DOXYGEN)
    SET(BUILD_BBTK_DOC_DOXYGEN OFF CACHE BOOL 
      "Build doxygen documentation. (doxygen)"		FORCE)
  ENDIF(BUILD_BBTK_DOC_DOXYGEN)
  
  IF(BUILD_BBTK_DOC_GUIDES_PDF)
    SET(BUILD_BBTK_DOC_GUIDES_PDF OFF CACHE BOOL 
      "Build bbtk Guides', PDF format (latex)."	FORCE)
  ENDIF(BUILD_BBTK_DOC_GUIDES_PDF)
  
  IF(BUILD_BBTK_DOC_GUIDES_HTML)
    SET(BUILD_BBTK_DOC_GUIDES_HTML OFF CACHE BOOL 
      "Build bbtk Guides', HTML format (latex tth)."		FORCE)
  ENDIF(BUILD_BBTK_DOC_GUIDES_HTML)
#  IF(BUILD_BBTK_DOC_SCRIPTS)
#    SET(BUILD_BBTK_DOC_SCRIPTS_HTML OFF CACHE BOOL 
#      "Build bbtk scripts documentation (bbi+dot)."		FORCE)
#  ENDIF(BUILD_BBTK_DOC_SCRIPTS)
  
ENDIF(BUILD_BBTK_DOC)
#-----------------------------------------------------------------------------

#-----------------------------------------------------------------------------
# BOOST C++
SET(BBTK_SHIPPED_BOOST boost_1_35_0 CACHE INTERNAL "Shipped boost dir" FORCE)
OPTION(BBTK_USE_SHIPPED_BOOST 
  "Use the shipped boost C++ library (${BBTK_SHIPPED_BOOST})" ON)
#-----------------------------------------------------------------------------

