

MACRO(FIND_AND_USE_WXWIDGETS)

  IF(WIN32)
    # Search WXWIDGETS
    
    #  WXWINDOWS_LIBRARY         = full path to the wxWindows library and linker flags on unix
    #  CMAKE_WX_CXX_FLAGS        = compiler flags for building wxWindows
    #  WXWINDOWS_INCLUDE_PATH    = include path of wxWindows
    #  WXWIDGETS_LIBRARIES       = wx libraries
    
    SET(WXWINDOWS_USE_GL 1)

    #wxWidgets build related stuff
    SET(WXW_USE_DEBUG    ON)
    SET(WXW_USE_UNICODE  OFF)
    SET(WXW_USE_SHARED   ON)
    SET(WXW_USE_UNIV     OFF)
    SET(WXW_USE_MONO     OFF)
    SET(WXW_FILE_VERSION "28")
    SET(WXW_VERSION      "2.8")
    
    #CMake Options
    SET(CMAKE_VERBOSE_MAKEFILE TRUE)
    
    INCLUDE (cmake/FindwxW.cmake)
    #
    SET(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}${WXWIDGETS_CXX_FLAGS}")
    SET(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS}${WXWIDGETS_EXE_LINKER_FLAGS}")
    ADD_DEFINITIONS( ${WXWIDGETS_DEFINITIONS}  )
    #
    INCLUDE_DIRECTORIES(${WXWIDGETS_INCLUDE_DIR})
    LINK_DIRECTORIES( ${WXWIDGETS_LINK_DIRECTORIES} )
    SET(WXWIDGETS_LIBRARIES
      ${WXWIDGETS_LIBRARIES}     
      debug msvcrtd
      debug msvcprtd
      optimized msvcrt
      optimized msvcprt
      )
  ENDIF(WIN32)
  IF(UNIX)
    # GTK2
    INCLUDE(cmake/FindGTK2.cmake)
    INCLUDE_DIRECTORIES(${GTK2_INCLUDE_DIRS})
    LINK_DIRECTORIES(${GTK2_LIBRARY_DIRS})
    LINK_LIBRARIES(${GTK2_LIBRARIES})
    # WX
    #SET(wxWidgets_USE_LIBS base core gl)
    FIND_PACKAGE( wxWidgets REQUIRED) 
    INCLUDE( ${wxWidgets_USE_FILE} )
    MARK_AS_ADVANCED(wxWidgets_CONFIG_EXECUTABLE)
    SET(WXWIDGETS_LIBRARIES
      ${wxWidgets_LIBRARIES}
      ${GTK2_LIBRARIES}
      )
    MARK_AS_ADVANCED(GTK2_CAIRO_INCLUDE_PATH)
    MARK_AS_ADVANCED(GTK2_GOBJECT_LIBRARY)
  ENDIF(UNIX)

ENDMACRO(FIND_AND_USE_WXWIDGETS)
  
