/*=========================================================================                                                                               
  Program:   bbtk
  Module:    $RCSfile: bbtkBlackBoxOutputConnector.h,v $
  Language:  C++
  Date:      $Date: 2008/10/17 08:18:12 $
  Version:   $Revision: 1.4 $
=========================================================================*/

/* ---------------------------------------------------------------------

* Copyright (c) CREATIS-LRMN (Centre de Recherche en Imagerie Medicale)
* Authors : Eduardo Davila, Laurent Guigues, Jean-Pierre Roux
*
*  This software is governed by the CeCILL-B license under French law and 
*  abiding by the rules of distribution of free software. You can  use, 
*  modify and/ or redistribute the software under the terms of the CeCILL-B 
*  license as circulated by CEA, CNRS and INRIA at the following URL 
*  http://www.cecill.info/licences/Licence_CeCILL-B_V1-en.html 
*  or in the file LICENSE.txt.
*
*  As a counterpart to the access to the source code and  rights to copy,
*  modify and redistribute granted by the license, users are provided only
*  with a limited warranty  and the software's author,  the holder of the
*  economic rights,  and the successive licensors  have only  limited
*  liability. 
*
*  The fact that you are presently reading this means that you have had
*  knowledge of the CeCILL-B license and that you accept its terms.
* ------------------------------------------------------------------------ */                                                                         


/**
 *  \file 
 *  \brief Class bbtk::BlackBoxOutputConnector : 
 */
/**
 * \class bbtk::BlackBoxOutputConnector
 * \brief 
 */
 
#ifndef __bbtkBlackBoxOutputConnector_h__
#define __bbtkBlackBoxOutputConnector_h__

#include "bbtkConnection.h"
#include "bbtkMessageManager.h"
#include <vector>

namespace bbtk
{


  class BBTK_EXPORT BlackBoxOutputConnector 
  {
  public:
     
    BlackBoxOutputConnector();
    ~BlackBoxOutputConnector();
    void SetConnection(Connection* c);
    void UnsetConnection(Connection* c);
    //IOStatus Update();
    void SetModifiedStatus();
    typedef std::vector<Connection*> ConnectionVector;
    const ConnectionVector& GetConnectionVector() const { return mConnection; }
    
  private:
    /// The vector of output connections
    ConnectionVector mConnection;
    /// The status of the output 
    //IOStatus mStatus;
  };
  
}
// namespace bbtk
#endif
